﻿package {
	import flash.display.Graphics;
	import flash.display.MovieClip;
	import flash.geom.Point;
	import flash.geom.Rectangle;
	import flash.utils.Timer;
	
	public class Paddle extends Rectangle {
		private var color:uint;
		private var bounce:int;
		private var bounceTimer:Timer;
		private var rate:int;
		
		public function Paddle(px:Number, py:Number, pw:Number, ph:Number,
								changing:Boolean):void {
			super(px, py, pw, ph);
			color = 0x000000;
			bounce = 0;
			if (changing) {
				bounceTimer = new Timer(1500);
				bounceTimer.addEventListener("timer", changeRate);
				bounceTimer.start();
			}
		}
		public function changeRate(evt):void {
			if (bounce == 0xFF) {
				rate = -Math.floor(5 * Math.random());
			} else if (bounce == -0xFF) {
				rate = Math.floor(5 * Math.random());
			} else {
				rate = Math.floor(11 * Math.random()) - 5;
			}
		}
		public function updateCollide():void {
			bounce += rate;
			bounce = Math.min(0xFF, Math.max(-0xFF, bounce));
			if (bounce > 0) {	// accelerate, red
				color = bounce << 16;
			} else {	// decelerate, blue
				color = -bounce;
			}
			// difference between center of this and p
            var dXY:Point = new Point(.5 * (left + right) - Pong.ball.x,
									.5 * (top + bottom) - Pong.ball.y);
            var pX:Number = .5 * width - Math.abs(dXY.x);
            if (pX > 0) {
                var pY:Number = .5 * height - Math.abs(dXY.y);
                if (pY > 0) {    // possible collision
                    if (pX < pY) {    // penetrated X
                        if (dXY.x > 0) {pX *= -1;}
                        if (Math.abs(pX) > .01) {
                            Pong.ball.x += pX;
							Pong.ballVel.x *= -bounceScale();
                        }
                    } else {    // penetrated Y
                        if (dXY.y > 0) {pY *= -1;}
						if (Math.abs(pY) > .01) {
                           Pong.ball.y += pY;
						   Pong.ballVel.y *= -bounceScale();
                        }
                    }
                }
            }
        }
		public function drawTo(m:MovieClip):void {
			m.graphics.beginFill(color);
			m.graphics.drawRect(left, top, width, height);
			m.graphics.endFill();
		}
		private function bounceScale():Number {
			return Math.pow(1.002, bounce);
		}
	}
}